//
//  Ajustes.h
//  iPark
//
//  Clase singleton que gestiona todos los ajustes de la aplicación
// 
//  Created by Mikel Elorz on 12/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//


#import <Foundation/Foundation.h>
#import "Idioma.h"

#define kKeyIdioma          @"idioma"
#define kKeyIntervalos      @"intervalos"
#define kKeyLocalizar       @"localizar"

// Indice del plist de preferencias en el que está idioma e intervalos
#define kIndiceIdiomas      1
#define kIndiceIntervalos   3


@interface Ajustes : NSObject {
    // Los tres parámetros que controla los ajustes:
    // Idioma de la aplicación
    Idioma *_idioma;
    // Intervalos de tiempo de alarma previos
    NSArray *_intervalos;
    // Si se permite la localización del usuario o no
    BOOL _sePuedeLocalizar;
}

@property (nonatomic , retain) Idioma *idioma;
@property (nonatomic , retain) NSArray *intervalos;
@property (nonatomic , assign) BOOL sePuedeLocalizar;

// Método que devuelve la única instancia de ajustes
+ (Ajustes *) instancia;

// Métodos para especificar un ajuste
- (void) ajustarIdiomaConInt: (int) idi;
- (void) ajustarIdioma: (Idioma *) idi;

- (void) ajustarIntervalosConPrimero: (int) i1 segundo: (int) i2 tercero: (int) i3;
- (void) ajustarIntervalos: (NSArray *) intervalos;

- (void) ajustarSePuedeLocalizar: (BOOL) localizar;

// Métodos que se llama cuando hay cambios en los ajustes
// o cuando se quiere forzar una actualización
- (void) cambiosEnPreferendias;

// Métodos que devuelven el conjunto de idiomas e intervalos disponibles
- (NSArray *) idiomasDisponibles;
- (NSArray *) intervalosDisponibles;


@end
