//
//  AjustesSeleccionarViewController.m
//  iPark
//
//  Created by Mikel Elorz on 05/06/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "AjustesSeleccionarViewController.h"


@implementation AjustesSeleccionarViewController
@synthesize valores = _valores;
@synthesize titulos = _titulos;
@synthesize ultimoIndexPath = _ultimoIndexPath;
@synthesize action = _action;
@synthesize target = _target;
@synthesize titulo = _titulo;
@synthesize explicacion = _explicacion;

- (id)initWithStyle:(UITableViewStyle)style {
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc {
    [_valores release];
    [_titulos release];
    [_ultimoIndexPath release];
    [_titulo release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad {
    [super viewDidLoad];
}

- (void)viewDidUnload {
    [super viewDidUnload];
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    // Que se nos notifique cuando la aplicación sale para polver a la pantalla de ajustes
    [[NSNotificationCenter defaultCenter] addObserver: self.navigationController
                                             selector: @selector(popViewControllerAnimated:) 
                                                 name: UIApplicationWillResignActiveNotification
                                               object: nil];
    
    self.title = [TraductorHash traducir: self.titulo];
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
    [[NSNotificationCenter defaultCenter] removeObserver: self];
}

- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    // Daría igual devolver el count del array de títulos
    return [self.valores count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *CellIdentifier = @"AjustesSeleccionarTableViewCell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    
    cell.textLabel.text = (NSString *) [self.titulos objectAtIndex: indexPath.row];
    // Si la cell es la del ultimo indexpath, marcarla
    if ( [indexPath isEqual: self.ultimoIndexPath] ) {
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
        // Color cogido midiendo el color de la selección en la pantalla de ajuste
        // del sistema
        cell.textLabel.textColor = [UIColor colorWithRed:0.22 green:0.33 blue: 0.53 alpha: 1];
    }
    return cell;
}

- (NSString *)tableView:(UITableView *)tableView titleForFooterInSection:(NSInteger)section {
    return [TraductorHash traducir: self.explicacion];
}


#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Quitar el color de relleno de la selección
    [self.tableView deselectRowAtIndexPath: indexPath animated: YES];
    
    // Si el nuevo indexpath es distinto al último (ha cambiado)
    if ( ![indexPath isEqual: self.ultimoIndexPath] ) {
        // Obtener la cell anterior y desmarcarla
        UITableViewCell *cellAnterior = [self.tableView cellForRowAtIndexPath: self.ultimoIndexPath];
        cellAnterior.accessoryType = UITableViewCellAccessoryNone;
        cellAnterior.textLabel.textColor = [UIColor darkTextColor];
        
        // Obtener la cell nueva y maracarla
        UITableViewCell *cellASeleccionar = [self.tableView cellForRowAtIndexPath: indexPath];
        cellASeleccionar.accessoryType = UITableViewCellAccessoryCheckmark;
        cellASeleccionar.textLabel.textColor = [UIColor colorWithRed:0.22 green:0.33 blue: 0.53 alpha: 1];
        
        // Guardar el indexPath actual como el anterior
        self.ultimoIndexPath = indexPath;
        
        // Como ha cambiado de valor, ejecutar la acción dada sobre el target dado
        // con el valor correspondiente a la fila selecconada
        [self.target performSelector: self.action withObject: [self.valores objectAtIndex: indexPath.row]];
        
        // Recargar la vista por si lo que se ha cambiado ha sido el idioma
        [self viewWillAppear: NO];
    }
}

@end
