//
//  ChinchetaSector.m
//  iPark
//
//  Created by Mikel Elorz on 09/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "AnnotationSectorView.h"
#define  _DEBUG

@implementation AnnotationSectorView

- (id)initWithAnnotation:(id <MKAnnotation>)annotation reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithAnnotation:annotation reuseIdentifier:reuseIdentifier];
    if (self != nil) {
        // Inicializamos con un frame en la misma posición pero con un tamaño de 200x30
        CGRect frame = self.frame;
        frame.size = CGSizeMake(200, 30);
        self.frame = frame;
        // Fondo transparente
        self.backgroundColor = [UIColor clearColor];
    }
    return self;
}

- (void)setAnnotation:(id <MKAnnotation>)annotation {
    [super setAnnotation:annotation];
    [self setNeedsDisplay];
}

// Método sobreescrito para dibujar la vista
- (void)drawRect:(CGRect)rect {
    AnnotationSector *annot = (AnnotationSector *) self.annotation;
    CGRect textRect = self.frame;
    textRect.origin = CGPointZero;
    // Añadir un label
    UILabel *label = [[UILabel alloc] initWithFrame: textRect];
    label.backgroundColor = [UIColor clearColor];
    // Con el título de la anotación
    label.text =  annot.title;
    label.textAlignment = UITextAlignmentCenter;
    label.font = [UIFont boldSystemFontOfSize:25];
    // Semi-transparente para que se vea el fondo
    label.textColor = [[UIColor darkTextColor] colorWithAlphaComponent:0.5];
    [label drawTextInRect:textRect];
    [label release];
}


@end
