//
//  CalcularTableViewController.m
//  iPark
//
//  Created by Mikel Elorz on 12/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "CalcularTableViewController.h"

// Descomentar para activar los logs
//#define _DEBUG4
// Descomentar para activar el botón de test
//#define _TEST
// Descomentar para mostrar los elementos
// vacios y poder sacar captura de pantalla
// para foto inicial
//#define _INICIO


@implementation CalcularTableViewController

@synthesize cellZona = _cellZona;
@synthesize cellFecha = _cellFecha;
@synthesize cellLCD = _cellLCD;
@synthesize cellAlarma = _cellAlarma;

@synthesize calc = _calc;

#pragma mark - Memoria e inicialización

- (id)initWithStyle:(UITableViewStyle)style {
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc {
    [_cellZona release];
    [_cellFecha release];
    [_cellLCD release];
    [_cellAlarma release];
    
    [_calc release];
    
    [super dealloc];
}

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}


#pragma mark - View lifecycle

- (void)viewDidLoad {
    [super viewDidLoad];
    
    // Instanciar la calculadora
    Calculadora *c = [[Calculadora alloc] init];
    self.calc = c;
    [c release];
    
    // Añadir la imagen de fondo
    UIImageView *iv = [[UIImageView alloc] initWithImage: [UIImage imageNamed: kImagenFondoTable]];
    self.tableView.backgroundView = iv;
    [iv release];
}

- (void)viewDidUnload {
    [self setCellZona:nil];
    [self setCellFecha:nil];
    [self setCellLCD:nil];
    [self setCellAlarma:nil];

    [self setCalc:nil];
    
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


// Método en el que se reseteará la interfaz a los valores por defecto cada vez que
// aparezca la vista
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    [[Ajustes instancia] cambiosEnPreferendias];

    
    // Poner el índice de cada sección
    kSeccionZona   = 0;
    kSeccionFecha  = 1;
    kSeccionLCD    = 2;
    kSeccionAlarma = 3;
    
    // Queremos que se nos notifique cuando la aplicación vuelve a estado activo para
    // resetear la interfaz (llamando a viewWillAppear)
    [[NSNotificationCenter defaultCenter] addObserver: self
                                             selector: @selector(appDidBecomeActive) 
                                                 name: UIApplicationDidBecomeActiveNotification
                                               object: nil];
    // Que se nos notifique cuando perdemos el foco para esconder el HUD
    [[NSNotificationCenter defaultCenter] addObserver: self
                                             selector: @selector(appWillResignActive) 
                                                 name: UIApplicationWillResignActiveNotification
                                               object: nil];
    
    /****************************************************************************/
    /*********************************** Zona ***********************************/
    /****************************************************************************/
    // Obtener la vista y seleccionar la zona azul
    UISegmentedControl *sc = (UISegmentedControl *) [self.cellZona viewWithTag: kZonaSegmentedTag];
    [sc setSelectedSegmentIndex: kZonaSegmentedIndexAzul];
    self.calc.zona = [[ZonaAzul instancia] zonaConIndice: kZonaSegmentedIndexAzul];
    
    /****************************************************************************/
    /********************************** Fecha ***********************************/
    /****************************************************************************/
    #ifdef _DEBUG
        NSLog(@"poniendo fecha");
    #endif
    // Poner la fecha del dia a ahora
    Fecha *f = [[Fecha alloc] initWithAhora];
    self.calc.fechaInicio = f;
    [f release];
    
    /****************************************************************************/
    /*********************************** LCD ************************************/
    /****************************************************************************/
    // Poner el LCD del tiempo arriba (por defecto).
    if ( [self estaAbajo: [self.cellLCD viewWithTag:kLCDTiempoViewTag] ] )
        [self interCambiaLCDs];
    
    Periodo *p = [[Periodo alloc] initWithHoras: kLCDHorasDefault minutos:kLCDMinDefault];
    //[self actualizaPeriodo: p animado: YES];
    self.calc.periodo = p;
    [p release];
    /****************************************************************************/

    
    // Con el periodo puesto, calcular los euros y la fecha de fin
    [self calculaResultadoAnimado: YES ];
    
    // Recargar datos de la tabla (para la traducción, hora, etc.)
    [self.tableView reloadData];
    
    // Añadir botón de test
    #ifdef _TEST
        UIButton *b = [UIButton buttonWithType: UIButtonTypeRoundedRect];
        b.frame = CGRectMake(0, 0, 40, 40);
        [b setTitle:@"Test" forState:UIControlStateNormal];
        [b addTarget:self action:@selector(test) forControlEvents:UIControlEventTouchUpInside];
        [self.tableView addSubview: b];
    #endif
    
}

// Función que será llamada cuando la aplicación vuelva al estado activo
// estando la pestaña calcular mostrada.
- (void) appDidBecomeActive {
    #ifdef _DEBUG
        NSLog(@"appdidbecome");
    #endif
    [self viewWillAppear:NO];
}

- (void) appWillResignActive {
    if (pHUD != nil ){
        #ifdef _DEBUG3
                NSLog(@"__%@__" , NSStringFromSelector( _cmd));
        #endif
        [pHUD hide: NO];
        [self hudWasHidden: pHUD];
    }
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    // Si el usuario navega fuera de la vista, ya no queremos que se nos notifique
    [[NSNotificationCenter defaultCenter] removeObserver: self];
    

}
- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
}
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

// Recarga los datos de una sección específica
- (void) recargaSeccion: (int) seccion {
    [self.tableView 
     reloadSections: [NSIndexSet indexSetWithIndex: seccion] 
     withRowAnimation: UITableViewRowAnimationNone
     ];
}

// Se llamará a este método para saber cuantas secciones hay
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    // Return the number of sections.
    return kNumSecciones;
}

// Se llamará a este método para saber cuantas filas tendrá cada sección
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    // Return the number of rows in the section.
    // Una cell por sección
    return 1;
}

// Se llamará a este método para saber la altura de cada sección
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    CGFloat res = 0;

    if (indexPath.section == kSeccionZona)
        res = kAltoZona;
    else if (indexPath.section == kSeccionFecha)
        res = kAltoFecha;
    else if (indexPath.section == kSeccionLCD)
        res = kAltoLCD;
    else if (indexPath.section == kSeccionAlarma)
        res = kAltoAlarma;
    
    return res;
}

// Método importante, en este es donde se configura cada cell antes de ser mostrada.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    #ifdef _DEBUG
        NSLog(@"cellForRow %d-%d" , indexPath.section , indexPath.row);
    #endif
    
    UITableViewCell *res = nil;
    
    /****************************************************************************/
    /*********************************** Zona ***********************************/
    /****************************************************************************/
    if (indexPath.section == kSeccionZona) {
        // Obtener el label descriptivo y ponerle el título traducido.
        UILabel *label = (UILabel *) [self.cellZona viewWithTag:kZonaLabelTag];
        label.text = [TraductorHash traducir:@"Zona"];
        #ifdef _INICIO
                label.text = @"";
        #endif
        
        // Obtener el número de segmentos que hay
        UISegmentedControl *sc = (UISegmentedControl *) [self.cellZona viewWithTag: kZonaSegmentedTag];
        int nSegmentos = sc.numberOfSegments;
        // Obtener el número de zonas que hay
        ZonaAzul *za = [ZonaAzul instancia];
        int nZonas = [[za zonas] count];
        #ifdef _DEBUG
            NSLog(@"n=%d" , nZonas);
        #endif
        // Se hace de esta manera por si en un futuro se añaden zonas
        for (int i = 0 ; i < nZonas ; ++i ) {
            Zona *z = [za zonaConIndice: i];
            // Si el segmento está, le cambiamos el nombre, sinó añadimos un nuevo segmento
            if (i >= nSegmentos )
                [sc insertSegmentWithTitle:[TraductorHash traducir: z.nombre] atIndex:i animated:NO];
            else
                [sc setTitle: [TraductorHash traducir: z.nombre] forSegmentAtIndex:i];
            #ifdef _INICIO
                [sc setTitle:@"" forSegmentAtIndex:i];
            #endif
                        
            #ifdef _DEBUG
                        NSLog(@"[%d]Zona: %@ , %@ , %@" ,i , [TraductorHash traducir: z.nombre] , z.maxEuros , z.maxTiempo);
            #endif
        }
        // Poner el resultado
        res = self.cellZona;
    }
    /****************************************************************************/
    /********************************** Fecha ***********************************/
    /****************************************************************************/
    else if (indexPath.section == kSeccionFecha ) {
        // Poner el título traducido
        UILabel *titulo = (UILabel *) [self.cellFecha viewWithTag:kFechaTituloTag];
        titulo.text = [TraductorHash traducir:@"Hora de comienzo"];
        #ifdef _INICIO
                titulo.text = @"";
        #endif

        // Obtener la hora de la calculadora y ponerla en el label
        UILabel *hora = (UILabel *) [self.cellFecha viewWithTag:kFechaHoraTag];
        // El método description devuelve la representación de la fecha de inicio
        // como string
        hora.text = [self.calc.fechaInicio description];   
        #ifdef _INICIO
                hora.text = @"";
        #endif
        
        
        // Poner el resultado
        res = self.cellFecha;
    }
    /****************************************************************************/
    /*********************************** LCD ************************************/
    /****************************************************************************/
    else if (indexPath.section == kSeccionLCD ) {
        // La fuente DBLCDTempBlack es una fuente que imita un display de 7 segmentos
        // Las unidades se muestran en labels separados y utilizamos la fuente del sistema
        // pero en italic, ya que DBLCDTempBlack está un poco inclinada
        
        UILabel *labelHoras = (UILabel *) [self.cellLCD viewWithTag:kLCDHorasTag];
        labelHoras.font = [UIFont fontWithName:@"DBLCDTempBlack" size:50.0];
        labelHoras.text = [self.calc.periodo horasString];
        #ifdef _INICIO
                labelHoras.text = @"";
        #endif
        UILabel *labelUnidadHoras = (UILabel *) [self.cellLCD viewWithTag:kLCDUnidadHorasTag];
        labelUnidadHoras.font = [UIFont italicSystemFontOfSize: 36.0];
        labelUnidadHoras.text = [TraductorHash traducir:@"h"];
    
        UILabel *labelMinutos = (UILabel *) [self.cellLCD viewWithTag:kLCDMinutosTag];
        labelMinutos.font = [UIFont fontWithName:@"DBLCDTempBlack" size:50.0];
        labelMinutos.text = [self.calc.periodo minutosString];
        #ifdef _INICIO
                labelMinutos.text = @"";
        #endif
        UILabel *labelUnidadMinutos = (UILabel *) [self.cellLCD viewWithTag:kLCDUnidadMinutosTag];
        labelUnidadMinutos.font = [UIFont italicSystemFontOfSize: 36.0];
        labelUnidadMinutos.text = [TraductorHash traducir:@"min"];
        
        UILabel *labelEuros = (UILabel *) [self.cellLCD viewWithTag:kLCDEurosLabelTag];
        labelEuros.font = [UIFont fontWithName:@"DBLCDTempBlack" size:50.0];
        labelEuros.text = [self.calc.euros description];
        #ifdef _INICIO
                labelEuros.text = @"";
        #endif
        UILabel *labelSimbolo = (UILabel *) [self.cellLCD viewWithTag:kLCDEurosSimboloTag];
        labelSimbolo.font = [UIFont italicSystemFontOfSize: 36.0];
        labelSimbolo.text = @"€";
        
        // Poner el resultado
        res = self.cellLCD;
    }
    /****************************************************************************/
    /********************************** Alarma ***********************************/
    /****************************************************************************/
    else if (indexPath.section == kSeccionAlarma ) {
        // Título del cell de alarma
        UILabel *titulo = (UILabel *) [self.cellAlarma viewWithTag: kAlarmaTituloTag];
        titulo.text = [TraductorHash traducir:@"Hora de fin"];
        #ifdef _INICIO
                titulo.text = @"";
        #endif
        
        // Poner el resultado
        res = self.cellAlarma;
    }
    return res;
}

#pragma mark - Table view delegate

// Cuando el usuario toque alguna de las filas se llamará a esta función
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Si toca la cell de la Fecha
    if (indexPath.section == kSeccionFecha) {
        // Creamos un ActionSheet
        UIActionSheet *as = [[FechaActionSheet alloc] 
                             initWithButton: [TraductorHash traducir:@"Seleccionar"]
                                   delegate: self];
        // Lo mostramos
        [as showFromTabBar:self.tabBarController.tabBar];   
        [as release]; 
        // Desmarcamos la fila
        [self.cellFecha setSelected:NO animated:YES];
    }
    // Si toca la cell de la Alarma
    else if ( indexPath.section == kSeccionAlarma ) {
        // Llamamos al método que se llama cuando el usuario toca el botón
        // [self ponerAlarma: nil];
    }
}

#pragma mark - Funciones auxiliares animacion
// Devuelve verdadero si el view no está arriba (y=0)
- (BOOL) estaAbajo: (UIView *) v {
    return (v.frame.origin.y != 0);
}

// Aumenta de tamaño los LCD en kMuevePixeles y mueve el de abajo
// (Contrapartida de reduceLCDs)
- (void) aumentaLCDs {
    
    UIView *tiempoView = [self.cellLCD viewWithTag: kLCDTiempoViewTag];
    UIView *eurosView = [self.cellLCD viewWithTag: kLCDEurosViewTag];
    
    // Vemos cual está arriba y cual abajo
    UIView *arriba;
    UIView *abajo;
    if ( [self estaAbajo: tiempoView] ) {
        abajo = tiempoView;
        arriba = eurosView;
    }
    else {
        abajo = eurosView;
        arriba = tiempoView;
    }
    
    // Nos guardamos el punto del centro del de abajo
    CGPoint abajoCenter = abajo.center;
    
    // El que está arriba redimensionarlo
    [UIView animateWithDuration: kMueveDuracion 
                          delay: 0
                        options: (UIViewAnimationOptionAllowUserInteraction |
                                  UIViewAnimationOptionBeginFromCurrentState )
                     animations: ^(void) {
                         
         // Redimensionar todas las subvistas.
         for (UIView *view in arriba.subviews) {
             CGRect f = view.frame;
             f.size.height += kMuevePixeles;
             view.frame = f;
         }
     } 
                     completion:^(BOOL finished) {
     } ];
    
    // El que está abajo moverlo kMuevePíxeles píxeles y redimensionarlo
    [UIView animateWithDuration: kMueveDuracion 
                          delay: 0
                        options: (UIViewAnimationOptionAllowUserInteraction |
                                  UIViewAnimationOptionBeginFromCurrentState )
                     animations: ^(void) {
         
         // Moverlo
         CGPoint newCenter = CGPointMake(abajoCenter.x, abajoCenter.y + kMuevePixeles);
         // Redimensionar subvistas
         abajo.center = newCenter;
         for (UIView *view in abajo.subviews) {
             CGRect f = view.frame;
             f.size.height += kMuevePixeles;
             view.frame = f;
         }
     }              
                     completion:^(BOOL finished) {
     } ];
    
}

// Reduce los LCD en kMuevePixeles y mueve el de abajo
// (Contrapartida de aumentaLCDs)
- (void) reduceLCDs {
    UIView *tiempoView = [self.cellLCD viewWithTag: kLCDTiempoViewTag];
    UIView *eurosView = [self.cellLCD viewWithTag: kLCDEurosViewTag];
    
    UIView *arriba;
    UIView *abajo;
    if ( [self estaAbajo: tiempoView] ) {
        abajo = tiempoView;
        arriba = eurosView;
    }
    else {
        abajo = eurosView;
        arriba = tiempoView;
    }
    
    CGPoint abajoCenter = abajo.center;
    
    // El que está arriba redimensionarlo
    [UIView animateWithDuration: kIntercambiaDuracion
                          delay: 0
                        options: (UIViewAnimationOptionAllowUserInteraction |
                                  UIViewAnimationOptionBeginFromCurrentState )
                     animations:^{
                         
         for (UIView *view in arriba.subviews) {
             CGRect f = view.frame;
             f.size.height -= kMuevePixeles;
             view.frame = f;
         }
     } 
                     completion:^(BOOL finished){
     } ];
    
    // El que está abajo redimensionarlo y moverlo para abajo
    [UIView animateWithDuration: kIntercambiaDuracion
                          delay: 0
                        options: (UIViewAnimationOptionAllowUserInteraction |
                                  UIViewAnimationOptionBeginFromCurrentState )
                     animations:^{
                         
         CGPoint newCenter = CGPointMake(abajoCenter.x, abajoCenter.y - kMuevePixeles);
         abajo.center = newCenter;
         for (UIView *view in abajo.subviews) {
             CGRect f = view.frame;
             f.size.height -= kMuevePixeles;
             view.frame = f;
         }
     } 
                     completion:^(BOOL finished){
     } ];
    
}

// Hace que la cell LCD se muestre arriba del todo para
// que sean visibles mientras se muestran los actionsheet

- (void) scrollLCDs {
    // Intercambia la primera sección (zona) con la tercera (LCD)
    int aux = kSeccionZona;
    kSeccionZona = kSeccionLCD;
    kSeccionLCD = aux;
    // Al recargar los datos, mostrará la cell de los LCD en la sección de más arriba
    // y el actionsheet ocultará el resto.
    [self.tableView reloadData];
}

// Método que intercambia la posición de los LCDs de manera animada
- (void) interCambiaLCDs {
#ifdef _DEBUG4
    NSLog(@"__%@__" , NSStringFromSelector( _cmd));
#endif
    UIView *tiempoView = [self.cellLCD viewWithTag: kLCDTiempoViewTag];
    UIView *eurosView = [self.cellLCD viewWithTag: kLCDEurosViewTag];
    
    // Guardarnos los centros de cada vista para intercambiarlos
    CGPoint tiempoCenter = tiempoView.center;
    CGPoint eurosCenter = eurosView.center;
    
    // Animar el movimiento de una view
    [UIView animateWithDuration: kIntercambiaDuracion
                          delay: 0
                        options: (UIViewAnimationOptionAllowUserInteraction |
                                  UIViewAnimationOptionBeginFromCurrentState )
                     animations:^{
                         
         eurosView.center = tiempoCenter;
     } 
                     completion:^(BOOL finished){
     } ];
    // Animar la otra
    [UIView animateWithDuration: kIntercambiaDuracion
                          delay: 0
                        options: (UIViewAnimationOptionAllowUserInteraction |
                                  UIViewAnimationOptionBeginFromCurrentState )
                     animations:^{
                         
         tiempoView.center = eurosCenter;
                     } 
                     completion:^(BOOL finished){
     } ];
}

// Método que hace oscilar horizontalmente una view en un intervalo de tiempo con 
// una amplitud medida en píxeles
- (void) agitaView: (UIView *) v conDuracion: (NSTimeInterval) dur amplitud: (int) a {
    #ifdef _DEBUG4
        NSLog(@"__%@__%@" , NSStringFromSelector( _cmd), [v class]);
    #endif
    // El movimiento tiene tres fases, la duración la dividimos en 3
    dur /= 3;
    
    CGFloat centro    = v.center.x;
    CGFloat derecha   = centro + a;
    CGFloat izquierda = centro - a;
    
    /** Mover hacia la derecha a píxeles **/
    [UIView animateWithDuration: dur
                          delay: 0
                        options: (UIViewAnimationOptionAllowUserInteraction |
                                  UIViewAnimationOptionBeginFromCurrentState )
                     animations:^ {
                         
         CGPoint c1 = v.center;
         c1.x = derecha;
         v.center = c1;
     } 
                     completion:^(BOOL finished){
    /** Al acabar, mover hacia la izquierda 2a píxeles **/
         [UIView animateWithDuration: dur
                               delay: 0
                             options: (UIViewAnimationOptionAllowUserInteraction |
                                       UIViewAnimationOptionBeginFromCurrentState )
                          animations:^ {
                              
              CGPoint c1 = v.center;
              c1.x = izquierda;
              v.center = c1;
          } 
                          completion:^(BOOL finished){
    /** Al acabar, mover hacia la izquierda a píxeles para volver a la posición inicial **/       
              [UIView animateWithDuration: dur
                                    delay: 0
                                  options: (UIViewAnimationOptionAllowUserInteraction |
                                            UIViewAnimationOptionBeginFromCurrentState )
                               animations:^ {
                                   
                   CGPoint c1 = v.center;
                   c1.x = centro;
                   v.center = c1;
               } 
                               completion:^(BOOL finished){
               } ];
          } ];
     } ];
}

// Método que hace desaparecer y aparecer una view en una duración determinada
- (void) resaltaView: (UIView *) v conDuracion: (NSTimeInterval) dur {
    // La animación se divide en dos fases, hacer la view transparente y 
    // volver a hacerla opaca.
    dur /=2;
    // Guardamos el alpha original
    CGFloat alfaOrig = v.alpha;
    
    // Hacemos que el alpha de la vista baje hasta 0.25
    [UIView animateWithDuration: dur
                          delay: 0
                        options: (UIViewAnimationOptionAllowUserInteraction |
                                  UIViewAnimationOptionBeginFromCurrentState )
                     animations: ^{
         
         v.alpha = 0.25;
     }
                     completion:^(BOOL finished) {
     // Devolvemos el alpha a su valor original
         [UIView animateWithDuration: dur
                               delay: 0
                             options: (UIViewAnimationOptionAllowUserInteraction |
                                       UIViewAnimationOptionBeginFromCurrentState )
                          animations:^(void) {
                              
              v.alpha = alfaOrig;
          } 
                          completion:^(BOOL finished) {
          } ];
     } ];
}

#pragma mark - IBActions interfaz

// Método que se llama cuando el usuario cambia la zona mediante el UISegmentedControl
- (IBAction)cambiaZona:(id)sender {
    // Obtenemos las vistas a modificar:
    CustomSegmentedControl *sc = (CustomSegmentedControl *) sender;
    UILabel *labelZona = (UILabel *) [self.cellZona viewWithTag: kZonaLabelTag];
    UILabel *labelFechaHora = (UILabel *) [self.cellFecha viewWithTag: kFechaHoraTag];
    UILabel *labelAlarmaFin = (UILabel *) [self.cellAlarma viewWithTag: kAlarmaFechaTag];
    
    UIImageView *imagenTiempo = (UIImageView *) [self.cellLCD viewWithTag: kLCDTiempoImagenTag];
    UIImageView *imagenEuros  = (UIImageView *) [self.cellLCD viewWithTag: kLCDEurosImagenTag];
    
    UIButton *botonAlarma = (UIButton *) [self.cellAlarma viewWithTag:kAlarmaBotonTag];
    UIColor *color = nil;
    // Para cada zona seleccionada:
    //   - Ponemos el color adecuado a:
    //      * El tinte del segmented control,
    //      * El label de la alarma,
    //      * El label de la fecha de comienzo
    //      * El label indicativo de zona
    //   - Ponemos la imagen del color correspondiente al LCD tiempo
    //   - Ponemos la versión más oscura de la imagen anterior al LCD euros
    //   - Ponemos las imágenes para los dos estados del botón de alarma (normal
    //     y highlighted
    switch ([sc selectedSegmentIndex]) {
        case kZonaSegmentedIndexAzul:
            color = [UIColor blueColor];
            imagenTiempo.image = [UIImage imageNamed:@"LCDAzul"];
            imagenEuros.image = [UIImage imageNamed:@"LCDAzul2"];
            
            [botonAlarma setImage: [UIImage imageNamed:@"botonAzul"]
                         forState: UIControlStateNormal];
            [botonAlarma setImage: [UIImage imageNamed:@"botonAzulSelec"]
                         forState: UIControlStateHighlighted];
            break;
        case kZonaSegmentedIndexNaranja:
            color = [UIColor orangeColor];
            imagenTiempo.image = [UIImage imageNamed:@"LCDNaranja"];
            imagenEuros.image = [UIImage imageNamed:@"LCDNaranja2"];
            [botonAlarma setImage: [UIImage imageNamed:@"botonNaranja"]
                         forState: UIControlStateNormal];
            [botonAlarma setImage: [UIImage imageNamed:@"botonNaranjaSelec"]
                         forState: UIControlStateHighlighted];
            break;
        case kZonaSegmentedIndexRoja:
            color = [UIColor redColor];
            imagenTiempo.image = [UIImage imageNamed:@"LCDRoja"];
            imagenEuros.image = [UIImage imageNamed:@"LCDRoja2"];
            [botonAlarma setImage: [UIImage imageNamed:@"botonRojo"]
                         forState: UIControlStateNormal];
            [botonAlarma setImage: [UIImage imageNamed:@"botonRojoSelec"]
                         forState: UIControlStateHighlighted];
            break;
        default:
            break;
    }
    // Poner el color
    sc.tintColor              = 
    labelAlarmaFin.textColor  = 
    labelFechaHora.textColor  = 
    labelZona.textColor       = color;

    // Actualizamos la zona con el objeto sacado del singleton ZonaAzul
    // Hará los cálculos necesarios...
    [self actualizaZona: [[ZonaAzul instancia] zonaConIndice: [sc selectedSegmentIndex]] animado:YES];
}

// Método que se llama al tocar el LCD que muestra el tiempo
- (IBAction)tocaLCDTiempo:(id)sender {
    // Subir los LCDs
    [self scrollLCDs];
    // Empequeñecerlos
    [self reduceLCDs];
    
    // Si la view que contiene al LCDTiempo está abajo, se intercambian
    // El campo siendo editado siempre debe estar arriba y el resultado abajo.
    if ( [self estaAbajo: [sender superview]] )
        [self interCambiaLCDs];
    
    // Instanciamos un actionsheet de tipo TiempoActionSheet
    UIActionSheet *as = [[TiempoActionSheet alloc] 
                         initWithButton: [TraductorHash traducir:@"Seleccionar"]
                         delegate: self
                         periodo: self.calc.periodo
                         maxTiempo: self.calc.zona.maxTiempo];
    
    // Y lo mostramos desde la barra de pestañas.
    [as showFromTabBar:self.tabBarController.tabBar];   
    [as release]; 
}

// Método que se llama al tocar el LCD que muestra los euros
// Prácticamente igual que tocaLCDTiempo pero instanciando un EurosActionSheet
- (IBAction)tocaLCDEuros:(id)sender {
    
    [self scrollLCDs];
    [self reduceLCDs];
    if ( [self estaAbajo: [sender superview]] )
        [self interCambiaLCDs];
    
    // Diferencia: Hay que calcular el resultado ya que a unos euros
    // le corresponden unos minutos pero sin embargo, a 3 minutos diferentes
    // le corresponden los mismos euros.
    [self calculaResultadoAnimado:NO];
    
    UIActionSheet *as = [[EurosActionSheet alloc] 
                         initWithButton: [TraductorHash traducir:@"Seleccionar"]
                         delegate: self
                            euros: self.calc.euros
                         maxEuros: self.calc.zona.maxEuros];
    
    [as showFromTabBar: self.tabBarController.tabBar];
    [as release]; 
}

// Método que se llama al tocar el botón de Alarma (tocando la cell de alarma también 
// se llamará a este método)
- (IBAction)ponerAlarma:(id)sender {
    NSString *minutosAntes = [TraductorHash traducir:@"minutos antes"];
    NSNumber *cantidad1 = [[[Ajustes instancia] intervalos] objectAtIndex: 0];
    NSNumber *cantidad2 = [[[Ajustes instancia] intervalos] objectAtIndex: 1];
    NSNumber *cantidad3 = [[[Ajustes instancia] intervalos] objectAtIndex: 2];
    NSString *boton1 = [NSString stringWithFormat: @"%@ %@" , cantidad1 ,minutosAntes];
    NSString *boton2 = [NSString stringWithFormat: @"%@ %@" , cantidad2 ,minutosAntes];
    NSString *boton3 = [NSString stringWithFormat: @"%@ %@" , cantidad3 ,minutosAntes];
    
    ActionSheetAutoDismiss *as = [[ActionSheetAutoDismiss alloc] 
                         initWithTitle: [TraductorHash traducir:@"Añadir alarma"]
                             delegate: self
                    cancelButtonTitle: [TraductorHash traducir:@"Cancelar"]
               destructiveButtonTitle: nil
                    otherButtonTitles: boton1 , boton2 , boton3 , nil];
    [as showFromTabBar: self.tabBarController.tabBar];
    [as release];
}

- (void) alarma: (NSNumber *) antelacion {
    #ifdef _DEBUG3
        NSLog(@"__%@__" , NSStringFromSelector( _cmd));
    #endif
    UILocalNotification *localNotif = [[UILocalNotification alloc] init];

    NSDate *fechaFinal = [self.calc calcularFechaFinal];
    localNotif.fireDate = [fechaFinal dateByAddingTimeInterval: -[antelacion intValue]*60 ];
    #ifdef _TEST
        localNotif.fireDate = [[[NSDate alloc] init] dateByAddingTimeInterval: [antelacion intValue]];
    #endif
    localNotif.timeZone = [NSTimeZone defaultTimeZone];
    
    NSDateFormatter *df = [[[NSDateFormatter alloc] init] autorelease];
    [df setDateFormat: @"HH:mm"];
    
    // Añadir la hora al detalle
 
    NSString *mensaje = [NSString stringWithFormat: 
                         [TraductorHash traducir:@"El periodo de aparcamiento termina en %@ minutos (%@)"],
                         antelacion ,
                         [df stringFromDate: fechaFinal]];
	// Notification details
    localNotif.alertBody = mensaje;
    localNotif.hasAction = NO;
    
    // Poner la hora de fin en el diccionario de userinfo
    localNotif.userInfo = [NSDictionary dictionaryWithObjectsAndKeys: 
                           fechaFinal , @"horaFin", nil ];
    
    localNotif.soundName = UILocalNotificationDefaultSoundName;
    
	// Schedule the notification
    [[UIApplication sharedApplication] scheduleLocalNotification:localNotif];
    [localNotif release];
}

#pragma mark - ActionSheet Delegate

// Función delegada de los actionsheet que será llamada:
//   - Cuando se oculten al pulsar el botón con buttonIndex > 0
//   - Para actualizar los valores dinámicamente, cuando el picker de los actionsheet
//     detecta una nueva fila seleccionada.
- (void) actionSheet:(UIActionSheet *)actionSheet willDismissWithButtonIndex:(NSInteger)buttonIndex {
    
    /**** Fecha Action Sheet ****/
    if ( [actionSheet isKindOfClass: [FechaActionSheet class]] ) {
        FechaActionSheet *fas = (FechaActionSheet *) actionSheet;
        // Actualizar la fecha con el valor sacado del actionsheet
        // No lo animamos al dismissear el actionsheet
        [self actualizaFecha: [fas fecha] animado: (buttonIndex == -1) ];
    }
    /**** Euros Action Sheet ****/
    else if ([actionSheet isKindOfClass: [EurosActionSheet class]]) {
        EurosActionSheet *eas = (EurosActionSheet *) actionSheet;
        // Actualizamos los euros y animamos solo cuando aún se está mostrando
        [self actualizaEuros:[eas euros] animado: (buttonIndex == -1) ];
        // Si se ha quitado el actionSheet, lo devolvemos a su posición
        if ( buttonIndex != -1 ) {
            [self scrollLCDs];
            [self aumentaLCDs];
        }
    }
    /**** Tiempo Action Sheet ****/
    else if ([actionSheet isKindOfClass: [TiempoActionSheet class]]) {
        TiempoActionSheet *tas = (TiempoActionSheet *) actionSheet;
        [self actualizaPeriodo: [tas periodo] animado: (buttonIndex == -1) ];
        if ( buttonIndex != -1 ) {
            [self scrollLCDs];
            [self aumentaLCDs];
        }
    }

}

- (void)actionSheet:(UIActionSheet *)actionSheet didDismissWithButtonIndex:(NSInteger)buttonIndex {
    if ([actionSheet numberOfButtons] == 4 ) {
        if (buttonIndex != 3 ) {
            // Agitamos el botón del lateral derecho
            UIButton *botonAlarma = (UIButton *) [self.cellAlarma viewWithTag: kAlarmaBotonTag];
            [self agitaView: botonAlarma conDuracion:0.2 amplitud:8];
            if ( pHUD == nil ) {
                // Indicador HUD
                // El hud interrumpe toda la interacción en la aplicación
                pHUD = [[MBProgressHUD alloc] initWithView: self.view.window];
                // Que notifique a esta misma clase
                pHUD.delegate = self;
                // Añadir la imagen como custom view
                pHUD.customView = [ [[UIImageView alloc]
                                        initWithImage:[UIImage imageNamed:@"anadeAlarma"]]
                                   autorelease];
                // Poner el modo como custom view
                pHUD.mode = MBProgressHUDModeCustomView;
                // Tipo de animación: Zoom
                pHUD.animationType = MBProgressHUDAnimationZoom;
                //Que se muestre un mínimo de 2 segundos
                pHUD.minShowTime = kMinTiempoHUD;
                // Añadir el HUD como subvista
                [self.view.window addSubview: pHUD];
                // Poner el título
                pHUD.labelText = [TraductorHash traducir:@"Alarma añadida"];
                pHUD.labelFont = [UIFont boldSystemFontOfSize: kTamanoFuenteHUD];
                
                // Obtener el subtítulo
                pHUD.detailsLabelText = [actionSheet buttonTitleAtIndex: buttonIndex];
                // Añadir la hora al subtitulo
                NSNumber *elegido = [[[Ajustes instancia] intervalos] objectAtIndex: buttonIndex];
                NSDate *fechaMostrar = [[self.calc calcularFechaFinal] 
                                        dateByAddingTimeInterval: -[elegido intValue]*60 ];
                NSDateFormatter *df = [[NSDateFormatter alloc] init];
                [df setDateFormat: @"HH:mm"];
                pHUD.detailsLabelText = [pHUD.detailsLabelText 
                                         stringByAppendingFormat: @" (%@)" , 
                                         [df stringFromDate: fechaMostrar]];
                [df release];
                pHUD.detailsLabelFont = [UIFont systemFontOfSize: kTamanoFuenteDetalleHUD];
                // Show the HUD while the provided method executes in a new thread
                [pHUD showWhileExecuting:@selector(alarma:) onTarget:self withObject: elegido animated:YES];
            }
        }

    }
}

#pragma mark - Cambiadores

// Método que se llama para cambiar la zona actual
- (void) actualizaZona: (Zona *) z animado: (BOOL) animado {
    // Si la zona es distinta:
    if ( ! [self.calc.zona isEqual: z] ) {
        // Nos quedamos la nueva zona
        self.calc.zona = z;
        
        // Si es animado agitamos el label y el segmented control
        if (animado) {
            UIView *labelZona = (UIView *) [self.cellZona viewWithTag: kZonaLabelTag];
            [self agitaView: labelZona conDuracion: 0.3 amplitud: 6];
            UISegmentedControl *sc = (UISegmentedControl *) [self.cellZona viewWithTag: kZonaSegmentedTag];
            [self agitaView: sc conDuracion:0.3 amplitud:6];
        }
        
        // Ahora tenemos que comprobar que los euros y el tiempo que están puestos
        // no se pasen del límite de la nueva zona
        
        // Si euros está abajo (abajo significa que es el resultado)
        if ( [self estaAbajo: [self.cellLCD viewWithTag: kLCDEurosViewTag]] ) {
            // Comprobamos que el periodo no se pase y si se pasa, actualizamos al máximo.
            if ( [self.calc.periodo esMayor: self.calc.zona.maxTiempo] ) {
                [self actualizaPeriodo: self.calc.zona.maxTiempo animado: NO];
            }
        }
        // Si tiempo está abajo
        else {
            // Comprobamos que los euros no se pasen
            if ( [self.calc.euros esMayor: self.calc.zona.maxEuros] ) {
                [self actualizaEuros: self.calc.zona.maxEuros animado: NO];
            }
        }
        
        // Calculamos el resultado (tarifa cambiada).
        // Se supone que los euros o periodo calculados serán correctos,
        // (por debajo de los máximos)
        [self calculaResultadoAnimado: YES ];
    }
}

// Cambia la fecha de inicio
- (void) actualizaFecha: (Fecha *) f animado: (BOOL) animado {
    if ( ! [self.calc.fechaInicio isEqual: f] ) {
        self.calc.fechaInicio = f;
        // Recarga sólo la sección afectada
        [self recargaSeccion: kSeccionFecha];
        if (animado) {
            UIView *labelFecha = (UIView *) [self.cellFecha viewWithTag: kFechaHoraTag];
            [self agitaView: labelFecha conDuracion: 0.3 amplitud: 6];
        }
        // calcula el resultado ya que cambiará la hora de fin.
        [self calculaResultadoAnimado: animado];
    }
}

- (void) actualizaPeriodo: (Periodo *) p animado: (BOOL) animado {
    if ( ! [self.calc.periodo isEqual: p ] ) {
        self.calc.periodo = p;
        [self recargaSeccion: kSeccionLCD];
        if (animado) {
            UIView *viewTiempo = (UIView *) [self.cellLCD viewWithTag: kLCDTiempoViewTag];
            [self agitaView: viewTiempo conDuracion: 0.3 amplitud: 6];
        }
        [self calculaResultadoAnimado: animado];
    }
}

- (void) actualizaEuros: (Euros *) e animado: (BOOL) animado {
    if ( ! [self.calc.euros isEqual: e] ) {
        self.calc.euros = e;
        [self recargaSeccion: kSeccionLCD];
        if (animado) {
            UIView *viewEuros = (UIView *) [self.cellLCD viewWithTag: kLCDEurosViewTag];
            [self agitaView: viewEuros conDuracion: 0.3 amplitud: 6];
        }
        [self calculaResultadoAnimado: animado];
    }
}


- (void) calculaResultadoAnimado: (BOOL) animado {
    #ifdef _DEBUG
        NSLog(@"__%@__" , NSStringFromSelector( _cmd));
    #endif
    
    /**** LCDs ****/
    UIView *eurosView = [self.cellLCD viewWithTag: kLCDEurosViewTag];
    UIView *tiempoView = [self.cellLCD viewWithTag: kLCDTiempoViewTag];
    
    // Si está abajo euros (abajo == resultado)
    if ( [self estaAbajo: eurosView] ) {
        // Calcular euros
        self.calc.euros = [self.calc calcularEuros];
        if (animado)
            [self resaltaView: eurosView conDuracion: 0.4];
    }
    // Si está abajo periodo
    else {
        // Calcular periodo
        self.calc.periodo = [self.calc calcularPeriodo];
        if (animado)
            [self resaltaView: tiempoView conDuracion: 0.4];
    }
    // Recarga la sección afectada
    [self recargaSeccion: kSeccionLCD];
    
    /**** Alarma ****/
    UILabel *labelAlarma = (UILabel *) [self.cellAlarma viewWithTag: kAlarmaFechaTag];
    // Obtener el formato adecuado (dia/mes horas:minutos)
    NSDateFormatter *df = [[NSDateFormatter alloc] init];
    [df setDateFormat: @"dd/MM HH:mm"];
    // Obtener el string de la fecha de la calculadora y asignarlo al label
    labelAlarma.text = [df stringFromDate: [self.calc calcularFechaFinal]];
    #ifdef _INICIO
        labelAlarma.text = @"";
    #endif
    
    #ifdef _DEBUG
        NSLog(@"__%@__" , self.calc.fechaInicio);
    #endif
    
    
    [df release];
    // Recarga la seccón de Alarma
    [self recargaSeccion: kSeccionAlarma];
    if (animado) 
        [self resaltaView: labelAlarma conDuracion: 0.4];
} 

#pragma mark - Método MBProgressHUDDelegate

- (void)hudWasHidden:(MBProgressHUD *)hud {
    #ifdef _DEBUG3
        NSLog(@"__%@__" , NSStringFromSelector( _cmd));
    #endif
    // Remove HUD from screen when the HUD was hidded
    [pHUD removeFromSuperview];
    [pHUD release];
    pHUD = nil;
}


# pragma mark - Test

- (void) test {
#ifdef _TEST
    NSLog(@"__%@__" , NSStringFromSelector( _cmd));
    
    Calculadora *ca = [[[Calculadora alloc] init] autorelease];
    
    // Naranja
    ca.zona = [[ZonaAzul instancia] zonaConIndice: kZonaSegmentedIndexNaranja];
    NSDateFormatter *df = [[NSDateFormatter alloc] init];
    [df setDateFormat: @"dd/MM/yyyy HH:mm"];
    
    NSLog(@"****************** Pruebas con papel real *************************");
    NSLog(@"Euros\tFechaInicial\t\t\t\t\t\t\t\t\tPeriodo\t\tFechaFinal");
    
    // Test1
    ca.euros = [[[Euros alloc] initWithEuros: 1 centimos: 0 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    NSString *fechaInicial = @"09/03/2011 13:20";
    NSDate *f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    
    // Test2
    ca.euros = [[[Euros alloc] initWithEuros: 1 centimos: 5 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"02/03/2011 11:45";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test3
    ca.euros = [[[Euros alloc] initWithEuros: 0 centimos: 70 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"05/08/2010 19:33";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test4
    ca.euros = [[[Euros alloc] initWithEuros: 0 centimos: 60 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"07/04/2011 18:08";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test5
    ca.euros = [[[Euros alloc] initWithEuros: 1 centimos: 0 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"03/03/2011 19:08";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test6
    ca.euros = [[[Euros alloc] initWithEuros: 1 centimos: 20 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"07/04/2011 16:52";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test7
    ca.euros = [[[Euros alloc] initWithEuros: 1 centimos: 70 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"03/03/2010 18:25";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test8
    ca.euros = [[[Euros alloc] initWithEuros: 2 centimos: 50 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"12/10/2010 17:19";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test9
    ca.euros = [[[Euros alloc] initWithEuros: 2 centimos: 15 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"05/01/2010 17:50";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test10
    ca.euros = [[[Euros alloc] initWithEuros: 1 centimos: 50 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"08/03/2011 18:40";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test11
    ca.euros = [[[Euros alloc] initWithEuros: 1 centimos: 30 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"01/03/2011 18:48";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test12
    ca.euros = [[[Euros alloc] initWithEuros: 1 centimos: 10 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"24/02/2011 19:01";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test13
    ca.euros = [[[Euros alloc] initWithEuros: 1 centimos: 50 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"15/02/2011 18:37";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test14
    ca.euros = [[[Euros alloc] initWithEuros: 2 centimos: 0 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"23/02/2011 18:10";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test15
    ca.euros = [[[Euros alloc] initWithEuros: 1 centimos: 0 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"11/02/2011 19:16";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test16
    ca.euros = [[[Euros alloc] initWithEuros: 1 centimos: 15 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"13/08/2010 18:59";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test17
    ca.euros = [[[Euros alloc] initWithEuros: 1 centimos: 65 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"10/08/2010 18:27";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    // Test18
    ca.euros = [[[Euros alloc] initWithEuros: 1 centimos: 0 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"15/10/2010 18:28";
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    
    
    NSLog(@"\n\n\n****************** Pruebas  Extra *************************");
    NSLog(@"Euros\tFechaInicial\t\t\t\t\t\t\t\t\tPeriodo\t\tFechaFinal"); 
    
    // Test manual 1
    ca.euros = [[[Euros alloc] initWithEuros: 4 centimos: 35 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"15/04/2011 19:30"; // viernes a las 19:30
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    
    
    // Test manual 2
    ca.euros = [[[Euros alloc] initWithEuros: 4 centimos: 35 ]autorelease];
    ca.periodo = [ca.zona calcularConEuros: ca.euros ];
    fechaInicial = @"15/04/2011 13:59"; // viernes a las mañana
    f = [ca calcularFechaFinalDesdeFecha: [df dateFromString: fechaInicial]];
    NSLog(@"%@\t%@\t\t\t\t\t\t\t\t\t%@\t%@\n\n" , ca.euros, fechaInicial , ca.periodo , [df stringFromDate:f]);
    
        
#endif
}


@end
