//
//  Chincheta.m
//  iPark
//
//  Created by Mikel Elorz on 09/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Coordenada.h"


@implementation Coordenada
@synthesize coord = _coord;

// Constructor con latitud y longitud
- (id)initWithLatitud: (float) lat longitud: (float) lon {
    self = [super init];
    if (self) {
        self.latitud = lat;
        self.longitud = lon;
    }
    return self;
}

// Constructor a partir de un string tipo '0.0000,1.1111'
- (id) initWithString: (NSString *) strCoord {
    self = [super init];
    if (self) {
        NSScanner *sc = [NSScanner scannerWithString:strCoord];
        float lat,lon;
        // En el string tenemos primero longitud, luego una coma y luego latitud
        [sc scanFloat:&lon];
        [sc scanUpToString:@"," intoString:nil];
        [sc setScanLocation: [sc scanLocation] + 1 ];
        [sc scanFloat:&lat];
        self.latitud = lat;
        self.longitud = lon;
    }
    return self;
}

- (float) latitud {
    return self.coord.latitude; 
}
- (float) longitud {
    return self.coord.longitude;
}

- (void) setLatitud:(float)latitud {
    self.coord = CLLocationCoordinate2DMake(latitud, self.longitud);
}

- (void)setLongitud:(float)longitud {
    self.coord = CLLocationCoordinate2DMake(self.latitud, longitud);
}

- (NSString *) description {
    return [NSString stringWithFormat: @"(%f,%f)" , self.latitud , self.longitud];
}



@end
