//
//  MCSegmentedControl.h
//
//  Thanks to Matteo Caldari
//  http://matteocaldari.it/2010/05/a-uisegmentedcontrol-with-custom-color/

#import <UIKit/UIKit.h>


@interface CustomSegmentedControl : UISegmentedControl {

	NSMutableArray *items;
	
	UIFont  *font;
	UIColor *selectedItemColor;
	UIColor *unselectedItemColor;
	
}

/**
 * Font for the segments with title
 * Default is sysyem bold 18points
 */
@property (nonatomic, retain) UIFont  *font;

/**
 * Color of the item in the selected segment
 * Applied to text and images
 */
@property (nonatomic, retain) UIColor *selectedItemColor;

/**
 * Color of the items not in the selected segment
 * Applied to text and images
 */
@property (nonatomic, retain) UIColor *unselectedItemColor;

@end
