//
//  Detalle.h
//  iPark
//
//  Un detalle es una fila que puede contener, además del título y
//  subtítulo, un texto y una imagen. Es un nodo hoja, es decir, 
//  la navegación termina en un detalle, no tendrá más secciones ni
//  filas subordinadas.
//  Se considera un detalle navegable cuando tiene texto (tenga o no
//  imagen).
//  Si no tiene texto, no se podrá visualizar en una vista de detalle;
//  será, simplemente, una fila con información.
//
//  Created by Mikel Elorz on 09/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Fila.h"

#define kTexto   @"texto"
#define kImagen  @"imagen"

// Un detalle es una fila
@interface Detalle : Fila {
    NSString *_texto;
    NSString *_imagen;
}

@property (nonatomic , retain ) NSString *texto;
@property (nonatomic , retain ) NSString *imagen;

// Inicializador por defecto
- (id)initWithIndice: (NSString *) ind;

// Método que mira si el detalle es igual al objeto dado
- (BOOL) isEqual:(id)object;
@end
