//
//  ElementoInfo.h
//  iPark
//
//  Clase que representa una elemento genérico de información
//
//  Created by Mikel Elorz on 25/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Ajustes.h"

/* Los nombres de los plist de donde se leen los datos */
// En el diccionario esquema aparece representada 
// la jerarquía de las diferentes secciones y tablas. 
// Este diccionario está formado únicamente por índices
#define kNombreDicEsquema   @"Esquema"
// En el diccionario de datos aparecen todas las entradas
// de datos, con el índice como clave y con los datos dentro
//
// Se define el nombre base, y para cada idioma debe añadirse
// un sufijos. P.e. InfoDatoseu para euskera
#define kNombreDicDatos     @"InfoDatos"



@interface ElementoInfo : NSObject {
    NSString *_indice;
}
// Un elemento de información tendrá, mínimo, un índice
// que lo identificará únicamente y representa su lugar
// en la jerarquía
@property (nonatomic , retain) NSString *indice;

// Inicializador por defecto
- (id)initWithIndice: (NSString *) ind;
// Método que mira si el detalle es igual al objeto dado
- (BOOL) isEqual:(id)object;

// Los diccionarios podrán accederse sólo para leerse
// además, sólo habrá una instancia de cada diccionario
// en memoria y, una vez cargada, durará hasta que
// finalice la aplicación
- (NSDictionary *) dicDatos;
- (NSDictionary *) dicEsquema;

@end
