//
//  ElementoInfo.m
//  iPark
//
//  Created by Mikel Elorz on 25/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ElementoInfo.h"
//#define _DEBUG2

// Sólo mantendremos una instancia de los diccionarios
static NSDictionary *_dicDatos = nil;
static NSDictionary *_dicEsquema = nil;
static int _idiomaGuardado = -1;

@implementation ElementoInfo
@synthesize indice = _indice;

// Inicializador por defecto
- (id)initWithIndice: (NSString *) ind {
    self = [super init];
    if (self) {
        self.indice = ind;
        #ifdef _DEBUG
                NSLog(@"__%@__" , NSStringFromSelector( _cmd) );
        #endif
    }
    return self;
}

- (void)dealloc {
#ifdef _DEBUG
    NSLog(@"__%@ 2__ " , NSStringFromSelector( _cmd) );
#endif
    [_indice release];
    [super dealloc];
}

// Método que mira si el detalle es igual al objeto dado
- (BOOL) isEqual:(id)object {
    BOOL res = FALSE;
    if  ( [object isKindOfClass: [self class]] ) {
        ElementoInfo *e = (ElementoInfo *) object;
        res = [self.indice isEqual: e.indice];
    }
    return res;
}

#pragma mark - Métodos para acceder a los diccionarios
// Los diccionarios no se liberarán hasta que termine la aplicación.
- (NSDictionary *) dicDatos {
    // Si no se ha accedido nunca al diccionario, instanciarlo
    Idioma *i = [[Ajustes instancia] idioma];
    if ( (_dicDatos == nil) || (i.idioma != _idiomaGuardado) ) {
        #ifdef _DEBUG2
                NSLog(@"__%@__%d %d %@" , NSStringFromSelector( _cmd), _idiomaGuardado, i.idioma , i.abreviatura);
        #endif
        _idiomaGuardado = i.idioma;
        NSString *nombreDicDatos = [NSString stringWithFormat:@"%@%@" , kNombreDicDatos , i.abreviatura];
        NSString *datosPath = [[NSBundle mainBundle] pathForResource: nombreDicDatos ofType: @"plist"];
        // Por si lo habíamos instanciado de antes, release
        // si es nil no pasa nada
        [_dicDatos release];
        _dicDatos = [[NSDictionary dictionaryWithContentsOfFile: datosPath] retain];
    }
    
    return _dicDatos;
}

- (NSDictionary *) dicEsquema {
    // Si no se ha accedido nunca al diccionario, instanciarlo
    if ( _dicEsquema == nil ) {
        #ifdef _DEBUG
                NSLog(@"__%@__" , NSStringFromSelector( _cmd));
        #endif
        NSString *esquemaPath = [[NSBundle mainBundle] pathForResource: kNombreDicEsquema ofType: @"plist"];
        _dicEsquema = [[NSDictionary dictionaryWithContentsOfFile: esquemaPath] retain];
    }
    return _dicEsquema;
}

@end
