//
//  Euros.m
//  iPark
//
//  Created by Mikel Elorz on 12/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Euros.h"


@implementation Euros
@synthesize euros = _euros;
@synthesize centimos = _centimos;

#pragma mark - Constructor, dealloc, ...

// Constructor con euros y céntimos
- (id)initWithEuros: (int) e centimos: (int) c {
    self = [super init];
    if (self) {
        self.euros = e;
        self.centimos = c;
    }
    return self;
}

- (void)dealloc {
    [super dealloc];
}

// Método que compara si self es igual al objeto dado
- (BOOL) isEqual:(id)object {
    BOOL res = FALSE;
    if  ( [object isKindOfClass: [self class]] ) {
        Euros *e = (Euros *) object;
        res = ( self.euros == e.euros &&
                self.centimos == e.centimos);
    }
    return res;
}

// Método que compara self con unos euros y devuelve verdadero
// si self > e
- (BOOL) esMayor: (Euros *) e {
    return ( ( self.euros > e.euros ) || 
            ( (self.euros == e.euros) && (self.centimos > e.centimos) ) 
            );
}

// Método que compara self con unos euros y devuelve verdadero
// si self >= e
- (BOOL) esMayorOIgual: (Euros *) e {
    return ( ( self.euros > e.euros ) || 
            ( (self.euros == e.euros) && (self.centimos >= e.centimos) ) 
            );
}

// Devuelve la representación como string de los euros
- (NSString *) description {
    return [NSString stringWithFormat: @"%d.%02d" , self.euros , self.centimos];
}


#pragma mark - Otros métodos

// Añade una cantidada (positiva o negativa) de céntimos
- (void) anadeCentimos: (int) cent {
    // Pasar todo a minutos
    int centTotal = self.euros*100 + self.centimos + cent;
    
    // No podemos tener menos de 0.00 euros
    if ( centTotal <= 0 ) {
        self.euros = 0;
        self.centimos = 0;
    }
    else {
        self.euros = centTotal / 100;
        self.centimos = centTotal % 100;
    }
}

@end
