//
//  EurosActionSheetDelegate.h
//  iPark
//
//  Created by Mikel Elorz on 12/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Euros.h"
#import "Zona.h"



// Números del componente
#define kComponenteEuros    0
#define kComponenteCentimos 1

// Anchura de cada componente
#define kAnchoEuros        100
#define kAnchoCentimos     100


// Para simular las ruedas circulares, tendrán muchas filas y se utilizarán módulos
#define kMAXROWS           60000


// Clase que desciende de actionsheetdelegate y que tiene un picker dentro (y un botón). 
// Además es delegate y datasource del picker
@interface EurosActionSheet : UIActionSheet <UIPickerViewDelegate , UIPickerViewDataSource> {
    // El picker que se mostrará en la parte de abajo
    UIPickerView *_picker;
    // Cierto si ya se han dispuesto los elementos del actionsheet
    BOOL layoutDone;
    
    // El número máximo de euros seleccionables
    Euros *_maxEuros;
    // Los euros y céntimos actuales
    int eurActual;
    int centActual;
}
@property (nonatomic, retain) UIPickerView *picker;
@property (nonatomic, retain) Euros *maxEuros;


// Constructor con un sólo botón el delegate especificado
- (id)initWithButton:(NSString *) buttonTitle delegate: (id<UIActionSheetDelegate>) deleg euros: (Euros *) eur maxEuros: (Euros *) mEuros;

// Accede a los euros reflejados en el picker
- (Euros *) euros;

@end
