//
//  Fecha.h
//  iPark
//
//  Clase que representa una hora y un string para representar la fecha
//  ("Hoy"/"Mañana")
//
//  Created by Mikel Elorz on 30/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "TraductorHash.h"

@interface Fecha : NSObject {
    NSString *_dia;
    int _horas;
    int _minutos;
}

@property (nonatomic , retain ) NSString *dia;
@property (readwrite , assign) int horas;
@property (readwrite , assign) int minutos;

// Constructor con la fecha de ahora
- (id)initWithAhora;
// Constructor con una fecha determinada
- (id) initWithDia: (NSString *) d horas: (int) h minutos: (int) m;
// Método que compara si un objeto representa la misma fecha
- (BOOL) isEqual:(id)object;
// Método que devuelve la representación del objeto como string
- (NSString *) description;

// Devuelve la fecha en formato NSDate
- (NSDate *) date;

@end
