//
//  FechaActionSheetDelegate.h
//  iPark
//
//  Created by Mikel Elorz on 12/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "TraductorHash.h"
#import "Fecha.h"

// Números del componente
#define kComponenteFecha  0
#define kComponenteHora   1
#define kComponenteMinuto 2

// Anchura de cada componente
#define kAnchoFecha       130
#define kAnchoHora        70
#define kAnchoMinuto      70

// Para simular las ruedas circulares, tendrán muchas filas y se utilizarán módulos
#define kMAXROWS          60000

// Clase que desciende de UIActionSheet y que tiene un picker dentro (y un botón). 
// Además es delegate y datasource del picker
@interface FechaActionSheet : UIActionSheet <UIPickerViewDelegate , UIPickerViewDataSource> {
    // El picker que se mostrará en la parte de abajo
    UIPickerView *picker;
    // Cierto si ya se han dispuesto los elementos del actionsheet
    BOOL layoutDone;
}
@property (nonatomic, retain) UIPickerView *picker;

// Constructor con un sólo botón y el delegate especificado
- (id)initWithButton:(NSString *) buttonTitle delegate: (id<UIActionSheetDelegate>) deleg;

// Accede a la fecha reflejada en el picker
- (Fecha *) fecha;


@end
