//
//  Fila.h
//  iPark
//
//  Clase que representa una fila genérica que aparecerá
//  en una tabla. Podrá ser un detalle (con o sin texto)
//  o una nueva tabla (que contendrá más secciones,
//  más filas, ...)
// 
//  Created by Mikel Elorz on 09/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ElementoInfo.h"

// Keys para el acceso al diccionario
#define kTitulo     @"titulo"
#define kSubtitulo  @"subtitulo"

// Una fila es un elemento de información
@interface Fila : ElementoInfo {
    NSString *_titulo;
    NSString *_subtitulo;
}

// Una fila tiene sólo título y subtítulo
@property (nonatomic , retain ) NSString *titulo;
@property (nonatomic , retain ) NSString *subtitulo;

// Inicializador por defecto
- (id)initWithIndice: (NSString *) ind;

// Método que mira si el detalle es igual al objeto dado
- (BOOL) isEqual:(id)object;


@end
