//
//  Idioma.h
//  iPark
//
//  Clase que engloba un int que representa un idioma
//
//  Created by Mikel Elorz on 29/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

#define kCastellano     0
#define kEuskera        1
#define kIngles         2

#define kAbrCastellano  @"es"
#define kAbrEuskera     @"eu"
#define kAbrIngles      @"en"

@interface Idioma : NSObject {
    // Una abreviatura para el idioma
    NSString *_abreviatura;
    // El identificador del idioma
    int _idioma;
}

@property (nonatomic , retain ) NSString *abreviatura;
@property (readwrite , assign) int idioma;

// Constructores
+ (Idioma *) idiomaConInt: (int) idi;

- (id)initWithIdioma: (int) idi;

// Idioma en forma de string largo
- (NSString *) description;

@end
