//
//  InfoDetailViewController.h
//  iPark
//
//  Clase que permite ver la imagen y el texto de
//  un objeto tipo detalle, también maneja el zoom
//
//  Created by Mikel Elorz on 12/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Detalle.h"

// La cantidad de zoom que se aplica con el
// doble tap o con el tap de 2 dedos
#define kZoomStep 1.5
// La cantidad máxima de zoom (6 -> 6x)
#define kMaxZoom  6.0
// La cantidad mínima de zoom (1 -> No se empequeñece nada)
#define kMinZoom  1.0

@interface InfoDetailViewController : UIViewController <UIScrollViewDelegate>{
    UIScrollView *_scrollView;
    UIImageView *_imageView;
    UITextView *_textView;
    UIView *_viewContenido;
    
    Detalle *_detalle;
}
// Objeto de donde se sacan los datos
@property (nonatomic, retain) Detalle *detalle;
/* Outlets */
// La vista que se encarga del scroll de la página entera
@property (nonatomic, retain) IBOutlet UIScrollView *scrollView;
// La vista que contiene todos los elementos de la página
@property (nonatomic, retain) IBOutlet UIView *viewContenido;
// La vista que contiene la imagen, dentro de viewContenido
@property (nonatomic, retain) IBOutlet UIImageView *imageView;
// La vista que contiene el texto (no editable, no scrollable)
// dentro de viewContenido
@property (nonatomic, retain) IBOutlet UITextView *textView;


// Método auxiliar para los gestos de zoom
- (CGRect)zoomRectForScale:(float)scale withCenter:(CGPoint)center;

@end
