//
//  InfoTableViewController.h
//  iPark
//
//  Clase que se encarga de mostrar secciones y filas
//  a partir de la información de un objeto tipo Tabla.
//
//  Created by Mikel Elorz on 12/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>

#import "TraductorHash.h"
#import "InfoDetailViewController.h"
#import "Tabla.h"
#import "Seccion.h"
#import "Detalle.h"

// El índice de la tabla raíz
#define kIndiceTablaInicial @"0"
// Altura, en píxeles de cada celda
#define kAltoCelda          50
// Tamaño de la fuente del título de la celda
#define kTamFuente          20

// Nombres de las imágenes a utilizar como:
// Fondo de la tabla
#define kImagenFondoTable   @"gradientBackgroundOscuro"
// Fondo de la celda
#define kImagenCell         @"cellGradientClaro"
// Fondo de la celda seleccionada
#define kImagenCellSelec    @"cellGradientOscuro"

@interface InfoTableViewController : UITableViewController {
    // La tabla de la que se obtienen las secciones y las filas
    Tabla *_tabla;
}

@property (nonatomic , retain) Tabla *tabla;

@end
