//
//  Periodo.h
//  iPark
//
//  Clase que representa un periodo de tiempo en horas y minutos
//
//  Created by Mikel Elorz on 12/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface Periodo : NSObject {
    int _horas;
    int _minutos;
}

@property (readwrite , assign) int horas;
@property (readwrite , assign) int minutos;

// Constructor con horas y minutos
- (id) initWithHoras: (int) h minutos: (int) m;
// Método que mira si el periodo es igual al objeto dado
- (BOOL) isEqual:(id)object;
// Método que devuelve verdadero si self < p
- (BOOL) esMayor: (Periodo *) p;
// Método que devuelve verdadero si self <= p
- (BOOL) esMayorOIgual: (Periodo *) p;
// Método que devuelve la representación del periodo como string
- (NSString *) description;

// Método que devuelve las horas como un string con el formato adecuado
- (NSString *) horasString;
// Método que devuelve los minutos como un string con el formato adecuado
- (NSString *) minutosString;
// Añade una cantidad de minutos (positiva o negativa)
// al periodo
- (void) anadeMinutos: (int) min ;

@end
