//
//  Periodo.m
//  iPark
//
//  Created by Mikel Elorz on 12/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Periodo.h"

//#define _DEBUG

@implementation Periodo

@synthesize horas = _horas;
@synthesize minutos = _minutos;

#pragma mark - Constructores, dealloc, comparadores ...

// Constructor con horas y minutos
- (id)initWithHoras: (int) h minutos: (int) m {
    self = [super init];
    if (self) {
        self.horas = h;
        self.minutos = m;
    }
    return self;
} 

- (void)dealloc {
    [super dealloc];
}

// Método que mira si el periodo es igual al objeto dado
- (BOOL) isEqual:(id)object {
    BOOL res = FALSE;
    if  ( [object isKindOfClass: [self class]] ) {
        Periodo *p = (Periodo *) object;
        res = ( self.horas == p.horas &&
                self.minutos == p.minutos);
    }
    return res;
}

// Método que devuelve verdadero si self < p
- (BOOL) esMayor: (Periodo *) p {
    #ifdef _DEBUG
        NSLog(@"__self=%@ p=%@__" , self , p);
    #endif
    // Verdadero si las horas son mayores que las horas o si son iguales, 
    // que los minutos sean mayores
    return ( ( self.horas > p.horas ) || 
            ( (self.horas == p.horas) && (self.minutos > p.minutos) ) 
            );
}
// Método que devuelve verdadero si self <= p
- (BOOL) esMayorOIgual: (Periodo *) p {
    // Verdadero si las horas son mayores que las horas o si son iguales,
    // que los minutos sean mayores o iguales
    return ( ( self.horas > p.horas ) || 
            ( (self.horas == p.horas) && (self.minutos >= p.minutos) ) 
            );
}

// Método que devuelve la representación del periodo como string
- (NSString *) description {
    return [NSString stringWithFormat: @"%@ h %@ min" , [self horasString] , [self minutosString]];
}


#pragma mark - Otros métodos

// Método que devuelve las horas como un string con el formato adecuado
- (NSString *) horasString {
    return [NSString stringWithFormat: @"%02d" , self.horas];
}

// Método que devuelve los minutos como un string con el formato adecuado
- (NSString *) minutosString {
    return [NSString stringWithFormat: @"%02d" , self.minutos];
}

// Añade una cantidad de minutos (positiva o negativa)
// al periodo
- (void) anadeMinutos: (int) min {
    // Pasar todo a minutos y sumar (o restar) los minutos dados
    int minTotal = self.horas*60 + self.minutos + min;
    
    // Si se nos queda menos que 0, ponemos 0.
    if ( minTotal <= 0 ) {
        self.horas = 0;
        self.minutos = 0;
    }
    else {
        self.horas = minTotal / 60;
        self.minutos = minTotal % 60;
    }
}

@end
