//
//  Seccion.h
//  iPark
//
//  Clase que representa una sección de información
//  Una sección sólamente tiene un título y una lista
//  de filas subordinadas.
//
//  Created by Mikel Elorz on 09/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ElementoInfo.h"
#import "Fila.h"
#import "Detalle.h"

// Key para acceder al campo del título en el diccionario
#define kTituloSeccion @"tituloSeccion"

// Una sección es un elemento de información
@interface Seccion : ElementoInfo {
    NSArray *_listaFilas;
    NSString *_tituloSeccion;
}

// Lista que almacena sólamente los índices
// de las filas bajo esta sección.
@property (nonatomic , retain) NSArray *listaFilas;
// Título de esta sección
@property (nonatomic , retain) NSString *tituloSeccion;

// Inicializador por defecto
- (id)initWithIndice: (NSString *) ind;

// Método que nos devuelve la enésima fila
// instanciada (la fila podrá ser tanto una 
// tabla como un detalle)
- (Fila *) filaNumero: (int) n;

// Devuelve el número de filas en la sección
- (int) numeroFilas;

@end
