//
//  Seccion.m
//  iPark
//
//  Created by Mikel Elorz on 09/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Seccion.h"
#import "Tabla.h"

@implementation Seccion
@synthesize listaFilas = _listaFilas;
@synthesize tituloSeccion = _tituloSeccion;

// Inicializador por defecto
- (id)initWithIndice: (NSString *) ind {
    // Init de elementoInfo
    self = [super initWithIndice:ind];
    if (self) {
        self.listaFilas = [[self dicEsquema] objectForKey: self.indice];

        NSDictionary *seccionDic = [[self dicDatos] objectForKey: self.indice];
        self.tituloSeccion = [seccionDic objectForKey: kTituloSeccion];
    }
    return self;
}

// Método que nos devuelve la enésima fila
// instanciada (la fila podrá ser tanto una 
// tabla como un detalle)
- (Fila *) filaNumero: (int) n {
    // El resultado será una fila (detalle o tabla)
    Fila *res;
    // Obtener el diccionario que contiene la info de la fila
    NSString *indiceFila = [self.listaFilas objectAtIndex: n];
    
    res = ([[[self dicEsquema] allKeys] containsObject: indiceFila])
    // Si el diccionario de esquema contiene el índice, es una tabla
    ? [[Tabla alloc] initWithIndice: indiceFila]
    // si no, es detalle
    : [[Detalle alloc] initWithIndice: indiceFila];
    
    return [res autorelease];
}

// Devuelve el número de filas en la sección
- (int) numeroFilas {
    return [self.listaFilas count];
}

- (void)dealloc {
    [_listaFilas release];
    [_tituloSeccion release];
    [super dealloc];
}

@end
