//
//  Sector.h
//  iPark
//
//  Clase que representa un sector de la zona azul con un número
//  un array de coordenadas y un color asociado.
//
//  Created by Mikel Elorz on 09/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Coordenada.h"
#import <CoreLocation/CoreLocation.h>

@interface Sector : NSObject {
    // El número del sector
    int _numero;
    // Array de coordenadas en el mapa
    NSArray *_coordenadas;
    // Color del overlay del sector
    UIColor *_color;
    // El array de coordenadas en forma de polígono
    MKPolygon *_poligono;
}

@property (nonatomic , retain) NSArray *coordenadas;
@property (nonatomic , assign) int numero;
@property (nonatomic , retain) UIColor *color;
@property (nonatomic , readonly) MKPolygon *poligono;

// constructor
- (id)initWithNumero: (int) num color: (UIColor *) col coordenadas: (NSArray *) coords;
// Método que devuelve el número de coordenadas que forman el sector
- (int) numCoordenadas;
// Método que devuelve el array de coordenadas como un MKPolygon
- (MKPolygon *) poligono;

@end
