//
//  Sector.m
//  iPark
//
//  Created by Mikel Elorz on 09/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Sector.h"


@implementation Sector
@synthesize coordenadas = _coordenadas;
@synthesize numero = _numero;
@synthesize color = _color;

- (id)initWithNumero: (int) num color: (UIColor *) col coordenadas: (NSArray *) coords {
    self = [super init];
    if (self) {
        self.numero = num;
        self.coordenadas = coords;
        self.color = col;
    }
    return self;
}

- (MKPolygon *) poligono {
    if ( _poligono == nil ) {
        int numCoord = [self numCoordenadas];
        // Array feo de C...
        CLLocationCoordinate2D *arrayCL = (CLLocationCoordinate2D *)
                                          malloc(numCoord * sizeof(CLLocationCoordinate2D));
        int i = 0;
        // Añadir todoas las coordenadas
        for (Coordenada *c in self.coordenadas)
            arrayCL[i++] = c.coord;
        
        _poligono = [MKPolygon polygonWithCoordinates: arrayCL count: numCoord];
        _poligono.title = [NSString stringWithFormat:@"%d" , self.numero];
        
        // Liberar el array cogido con malloc
        free( arrayCL );
    }
    return _poligono;
}

- (int) numCoordenadas {
    return [self.coordenadas count];
}

- (void)dealloc {
    [_coordenadas release];
    [_color release];
    [super dealloc];
}

@end
