//
//  SectoresViewController.h
//  Controladora de la vista de sectores
//
//  Created by Mikel Elorz on 12/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <MapKit/MapKit.h>
#import "FDCurlViewControl.h"
#import "ZonaAzul.h"
#import "AnnotationSectorView.h"
#import "AnnotationSector.h"
#import "CustomSegmentedControl.h"

// Constantes del botón de curl
#define kAnchoBotonCurl     40
#define kAltoBotonCurl      40

// Tags de las subvistas
#define kBotonCurlTag       1
#define kLabelCentrarTag    2
#define kLabelLocalizarTag  3
#define kBotonoLocalizarTag 4
#define kSegmentedTag       5

// Indices del segment control de tipo de mapa
#define kSegmentoMapa       0
#define kSegmentoSatelite   1
#define kSegmentoHibrido    2

// Ancho del borde de los sectores
#define kAnchoLineaOverlay  3

@interface SectoresViewController : UIViewController <MKMapViewDelegate, FDCurlViewControlDelegate> {
    MKMapView *_mapView;
    // El control que hace subir y bajar el mapa
    FDCurlViewControl *_curlView;
    // Controla si al bajarse el view debe centrarse el mapa en la ciudad
    BOOL debeCentrarse;
    // Controla si la próxima vez que se localize al usuario
    // debe centrarse en su posición.
    BOOL debeIrALocalizacion;
}

@property (nonatomic, retain) IBOutlet MKMapView *mapView;
@property (nonatomic, retain) FDCurlViewControl *curlView;

// Función que centra el mapa en una región concreta en el centro de la ciudad
- (void) irAlCentro: (BOOL) animado;
// Función que centra el mapa en la localización actual del usuario
- (void) irALocalizacionUsuario: (BOOL) animado;
// Función que cicla por los tipos de mapa hacia la derecha, para swipe derecha
- (void) ciclaTiposMapaDerecha;
// Función que cicla por los tipos de mapa hacia la izquierda, para swipe izquierda
- (void) ciclaTiposMapaIzquierda;
// Función que conmuta entre mapa subido y mapa bajado
- (IBAction)conmutaCurl:(id)sender;
// Función que se llama al pulsar el botón de centrar
- (IBAction) botonCentrar;
// Función que conmuta entre encender y apagar la localización
// del usuario
- (IBAction)conmutaLocalizar:(id)sender;
// Función que se llama cuando cambia el valor del segmented control
// que gestiona el tipo de mapa
- (IBAction)cambiaMapa:(id)sender;

@end
