//
//  TiempoActionSheetDelegate.h
//  iPark
//
//  Created by Mikel Elorz on 12/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Periodo.h"
#import "Zona.h"

// Números del componente
#define kComponenteHoras    0
#define kComponenteMinutos  1

// Anchura de cada componente
#define kAnchoHoras         100
#define kAnchoMinutos       100

// Para simular las ruedas circulares, tendrán muchas filas y se utilizarán módulos
#define kMAXROWS            60000


@interface TiempoActionSheet : UIActionSheet <UIPickerViewDelegate , UIPickerViewDataSource> {
    // El picker que se mostrará en la parte de abajo
    UIPickerView *_picker;
    // Cierto si ya se han dispuesto los elementos del actionsheet
    BOOL layoutDone;
    
    // El periodo máximo seleccionable
    Periodo *_maxTiempo;
    // La hora y minuto actualmente seleccionados
    int horaActual;
    int minActual;
}

@property (nonatomic, retain) UIPickerView *picker;
@property (nonatomic, retain) Periodo *maxTiempo;

// Constructor con un sólo botón el delegate especificado
- (id)initWithButton:(NSString *) buttonTitle delegate: (id<UIActionSheetDelegate>) deleg periodo: (Periodo *) per maxTiempo: (Periodo *) mTiempo;


- (Periodo *) periodo;
@end
