//
//  TraductorHash.m
//  iPark
//
//  Created by Mikel Elorz on 17/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "TraductorHash.h"
//#define _DEBUG

// Diccionario estático, una sola copia en RAM durante toda la ejecución del programa
static NSDictionary *dic = nil;

@implementation TraductorHash

// Cuando la clase se instancia por primera vez,
+ (void) initialize {
    NSString *diccPath = [[NSBundle mainBundle] pathForResource: @"Diccionario" ofType:@"plist"];
    dic = [[NSDictionary alloc] initWithContentsOfFile: diccPath];
}

+ (NSString *) traducir: (NSString *) st {
    NSString *res;
    // Si el string no es vacío
    if ( st != nil && ![st isEqual:@""] ) {
        int idioma = [Ajustes instancia].idioma.idioma;
        if ( idioma == kCastellano )
            res = st;
        else {
            res = [[dic objectForKey: st] objectAtIndex: (idioma-1) ];
            if ( res == nil ) {
                // Si es nil, está sin traducir
                res = st;
                #ifdef _DEBUG
                    NSLog(@"Sin traducir: _%@_" , st);
                #endif
            }                
        }
        return res;
    }
    else // st == nil
        res = st;
    
    return res;
}

@end
