//
//  ZonaAzul.h
//  iPark
//
//  Clase Singleton que representa la información sobre la zona azul,
//  los diferentes sectores y las diferentes zonas.
// 
//  Created by Mikel Elorz on 09/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Zona.h"
#import "Sector.h"
#import "TraductorHash.h"

// Keys para leer la información del plist
#define kNombrePlist        @"ZonaAzul"
//   Keys de zonas:
#define kKeyZonas           @"Zonas"
#define kKeyZonaNombre      @"nombre"
#define kKeyZonaTarifa      @"tarifa"
#define kKeyZonaMaxHoras    @"maxHoras"
#define kKeyZonaMaxMinutos  @"maxMinutos"
#define kKeyZonaMaxEuros    @"maxEuros"
#define kKeyZonaMaxCentimos @"maxCentimos"
//   Keys de sectores
#define kKeySectores        @"Sectores"

// Archivos KML
#define kURLKMLOnline       @"http://maps.google.es/maps/ms?ie=UTF8&t=f&ecpose=40.396764,-3.713379,1054163.28,0,0,0&hl=es&vps=2&jsv=338a&msa=0&output=kml&msid=212852501871481854737.0004a3006572d5bf90e2c"
#define kFicheroKMLOffline  @"sectores"
#define kExtenKMLOffline    @"kml"

@interface ZonaAzul : NSObject {
    // Arrays de zonas y sectores
    NSArray *_sectores;
    NSArray *_zonas;
}

// La zona azul va a tener un array de sectores y un array de zonas
@property (nonatomic , retain) NSArray *sectores;
@property (nonatomic , retain) NSArray *zonas;

// Método de clase que devuelve la instacia de la Zona Azul y la crea de ser necesario
+ (ZonaAzul *) instancia;

// Devuelve la zona con la posición i del array de zonas
- (Zona *) zonaConIndice: (int) i;

// Sirve para inicializar el array de sectores, también sirve
// para recargar el array de sectores si queremos actualizarlo
- (void) iniciaSectores;

// Devuelve un objeto tipo sector correspondiente al n-esimo sector
- (Sector *) sectorNumero: (int) n;

// Devuelve el número de sectores actualmente cargados
- (int) numSectores;

@end
