//
//  iParkAppDelegate.m
//  iPark
//
//  Created by Mikel Elorz on 12/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "iParkAppDelegate.h"
#import "AlarmasTableViewController.h"
#define _DEBUG2
//#define _INICIO
@implementation iParkAppDelegate


@synthesize tabBarController = _tabBarController;
@synthesize window=_window;
@synthesize flechaTabBar;

#pragma mark - Notificaciones

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.

    // Aadir el tabBarController
    self.window.rootViewController = self.tabBarController;
    // Aadir la flecha indicadora de la posicin
    [self anadeFlecha];
    
    // Handle launching from a notification
    UILocalNotification *localNotif =
    [launchOptions objectForKey:UIApplicationLaunchOptionsLocalNotificationKey];
    if (localNotif) {
        // De momento no hacemos nada
        //[self application:application didReceiveLocalNotification:localNotif];
        #ifdef _DEBUG
            NSLog(@"__%@__ Notificacion cuando inactivo" , NSStringFromSelector( _cmd));
        #endif
    }
    
    // Registrar para cambios en defaults
    NSNotificationCenter *center = [NSNotificationCenter defaultCenter];
    [center addObserver: [Ajustes instancia]
               selector: @selector(cambiosEnPreferendias)  
                   name: NSUserDefaultsDidChangeNotification
                 object: nil];

    // Cargar los defaults
    [[NSUserDefaults standardUserDefaults] registerDefaults:
     [NSDictionary dictionaryWithContentsOfFile:
      [[NSBundle mainBundle] pathForResource:@"Defaults" ofType:@"plist"]]];
    
    [self.window makeKeyAndVisible];
    return YES;
}

- (void)application:(UIApplication *)app didReceiveLocalNotification:(UILocalNotification *)notif {
    // Handle the notificaton when the app is running
    #ifdef _DEBUG
        NSLog(@"Recieved Notification %@",notif);
    #endif
    if ( self.tabBarController.selectedIndex == kIndexAlarmas ) {
        #ifdef _DEBUG
            NSLog(@"_estamos en alarmas_");
        #endif
        // Si estamos en el tab de alarmas, recargamos la vista para eliminar
        // la alarma que acaba de aparecer
        [self.tabBarController.selectedViewController viewWillAppear: NO];
        
    }
    UIAlertView *av = [[UIAlertView alloc] 
                       initWithTitle: [TraductorHash traducir:@"Alarma"]
                             message: notif.alertBody
                            delegate: nil
                   cancelButtonTitle: [TraductorHash traducir:@"OK"]
                   otherButtonTitles: nil];
    [av show];
    [av release];

}

- (void)applicationWillResignActive:(UIApplication *)application {
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}

- (void)applicationDidEnterBackground:(UIApplication *)application {
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
     */
}

- (void)applicationWillEnterForeground:(UIApplication *)application {
    /*
     Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
     */
}

- (void)applicationDidBecomeActive:(UIApplication *)application {
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
    [self recargarTitulos];
}

- (void)applicationWillTerminate:(UIApplication *)application {
    /*
     Called when the application is about to terminate.
     Save data if appropriate.
     See also applicationDidEnterBackground:.
     */
}

- (void)applicationSignificantTimeChange:(UIApplication *)application {
    [[ZonaAzul instancia] iniciaSectores];
#ifdef _DEBUG
    NSLog(@"__%@__" , NSStringFromSelector( _cmd));
#endif
}

- (void)dealloc {
    [_window release];
    [_tabBarController release];
    [super dealloc];
}


#pragma mark - Cambio idioma tabBar

- (void) recargarTitulos {
    // Cargar los ttulos de las pestaas con strings traducidos
    [[self.tabBarController.tabBar.items objectAtIndex: kIndexCalcular] setTitle: [TraductorHash traducir: @"Calcular"]];
    [[self.tabBarController.tabBar.items objectAtIndex: kIndexSectores] setTitle: [TraductorHash traducir: @"Sectores"]];
    [[self.tabBarController.tabBar.items objectAtIndex: kIndexInfo]     setTitle: [TraductorHash traducir: @"Info"]];
    [[self.tabBarController.tabBar.items objectAtIndex: kIndexAlarmas]  setTitle: [TraductorHash traducir: @"Alarmas"]];
    [[self.tabBarController.tabBar.items objectAtIndex: kIndexAjustes]  setTitle: [TraductorHash traducir: @"Ajustes"]];
    
#ifdef _INICIO
    [[self.tabBarController.tabBar.items objectAtIndex: kIndexCalcular] setTitle: nil];
    [[self.tabBarController.tabBar.items objectAtIndex: kIndexSectores] setTitle: nil];
    [[self.tabBarController.tabBar.items objectAtIndex: kIndexInfo]     setTitle: nil];
    [[self.tabBarController.tabBar.items objectAtIndex: kIndexAlarmas]  setTitle: nil];
    [[self.tabBarController.tabBar.items objectAtIndex: kIndexAjustes]  setTitle: nil];
#endif
}


#pragma mark - flecha TabBar

// Crea y muestra la imagen de la flecha que seala al tab seleccionado
- (void) anadeFlecha {
    // Conseguir la imagen con metodo de conveniencia
    UIImage *flechaTabBarImage = [UIImage imageNamed:kNombreFlecha];
    //Crear un UIImageView a partir de la imagen
    self.flechaTabBar = [ [ [UIImageView alloc]
                           initWithImage:flechaTabBarImage]
                         autorelease];
    // Calcular la posicin vertical a partir de parmetros disponibles
    CGFloat posVertical =   self.window.frame.size.height
                          - self.tabBarController.tabBar.frame.size.height
                          - flechaTabBarImage.size.height
                          + kPosFlecha;
    // Asignarle su posicin
    flechaTabBar.frame = CGRectMake(
        //             x                 ,      y
        [self posHorizontalParaIndice:0] ,  posVertical,
        //             w                 ,      h
        flechaTabBarImage.size.width     ,  flechaTabBarImage.size.height
    );
    // Aadir la subvista
    [self.tabBarController.view addSubview:flechaTabBar];
}

// Funcin que devuelve la posicin del punto medio del tab nmero indiceTab
- (CGFloat) posHorizontalParaIndice: (NSUInteger)indiceTab {
    // Calcular el ancho de un tab
    CGFloat anchoTab =   self.tabBarController.tabBar.frame.size.width 
                       / self.tabBarController.tabBar.items.count;
    // Calcular la mitad del ancho de un tab
    CGFloat anchoMedioTab =   (anchoTab / 2.0) 
                            - (flechaTabBar.frame.size.width / 2.0);
    
    return (indiceTab * anchoTab) + anchoMedioTab;
}


// El tabbar nos notifica cuando cambia de tab (metodo del delegate)
- (void) tabBarController:(UITabBarController *)theTabBarController
  didSelectViewController:(UIViewController *)viewController {
    // Empezar la animacin con core animation (block approach)
    [UIView animateWithDuration: kDuracion 
                          delay: 0 
                                  // Que empiece rpido y que termine despacio
                        options: (UIViewAnimationOptionCurveEaseOut |
                                  // Que se pueda interactuar con la interfaz mientras dure la animacin
                                  UIViewAnimationOptionAllowUserInteraction | 
                                  // Si se interrumpe, se empieza del estado actual, no desde el principio
                                  UIViewAnimationOptionBeginFromCurrentState )
                     animations:^(void) {
                         // flechaTabBar.frame.origin.x no se puede modificar por lo que 
                         // leemos todo el frame en auxFrame,
                         CGRect auxFrame = flechaTabBar.frame;
                         // lo modificamos
                         auxFrame.origin.x = [self posHorizontalParaIndice: self.tabBarController.selectedIndex ];
                         // y lo volvemos a asignar
                         flechaTabBar.frame = auxFrame;
                     } completion:^(BOOL finished) {
                     }
     ];
}




@end
